program hdvalet;

// Copyright  1999 by Ziff-Davis, Inc.
// Written by Neil J. Rubenking

uses
  Forms,
  Windows,
  mainu in 'mainu.pas' {HDForm},
  AboutBox in 'Aboutbox.pas' {AboutForm},
  allfuncs in 'AllFuncs.pas',
  junkwizu in 'junkwizu.pas' {TypeWiz},
  hdObjs in 'hdObjs.pas',
  propu in 'propu.pas' {PropForm},
  nufpicku in 'nufpicku.pas' {NewPickForm},
  getspecu in 'getspecu.pas' {SpecForm},
  defaultu in 'defaultu.pas' {DefaultForm},
  legendu in 'legendu.pas' {LegendForm},
  getnameu in 'getnameu.pas' {NameForm},
  pmatchu in 'pmatchu.pas',
  FoundU in 'FoundU.pas' {FoundForm};

{$R *.RES}
TYPE
  THandles = Record
    AppHandle : THandle;
    WinHandle : THandle;
  end;
VAR
  hMap : THandle;
  PH   : ^THandles;
CONST
  MainMapName : PChar = 'PC Magazine HDValet Shared';
begin
  hMap := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, MainMapName);
  IF hMap = 0 THEN // first instance
    begin
      hMap := CreateFileMapping($FFFFFFFF, NIL, PAGE_READWRITE, 0,
        2*SizeOf(Integer), MainMapName);
      PH := MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
      Application.Initialize;
      Application.Title := 'HDValet';
      Application.CreateForm(THDForm, HDForm);
  HDForm.HandleNeeded;
      PH^.AppHandle := Application.Handle;
      PH^.WinHandle := HDForm.Handle;
      Application.Run;
    end
  ELSE
    begin
      PH := MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
      IF IsIconic(PH^.AppHandle) THEN
        ShowWindow(PH^.AppHandle, SW_RESTORE);
      SetForegroundWindow(PH^.WinHandle);
    end;
  UnMapViewOfFile(PH);
  CloseHandle(hMap);
end.
